import { Component } from 'react';
import { ApplicationTranslatorT } from '../../translation';
import { IApplicationSettings } from '../../settings';
import { IDateConverter, INumberConverter } from '../../converter';
import { IUniversalComponentPlugin, IUniversalComponent } from '../../entities-definitions.interface';
import { IUniversalComponentProps } from '../../props-definitions.interface';
import { IUIFactory } from '../factory/factory.interface';
export declare class UniversalComponent<TComponent extends IUniversalComponent<TProps, TState>, TProps extends IUniversalComponentProps = IUniversalComponentProps, TState = {}> extends Component<TProps, TState> implements IUniversalComponent<TProps, TState> {
    protected plugins: IUniversalComponentPlugin[];
    /**
     * @stable [23.04.2018]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [23.04.2018]
     */
    componentDidMount(): void;
    /**
     * @stable [23.04.2018]
     */
    componentWillUnmount(): void;
    /**
     * @stable [23.04.2018]
     * @param {Readonly<TProps extends IUniversalComponentEntity>} prevProps
     * @param {Readonly<TState>} prevState
     * @param {never} prevContext
     */
    componentDidUpdate(prevProps: Readonly<TProps>, prevState: Readonly<TState>, prevContext?: never): void;
    /**
     * @stable [18.05.2018]
     * @returns {Element}
     */
    readonly self: Element;
    /**
     * @stable [19.04.2018]
     * @returns {ApplicationTranslatorT}
     */
    protected readonly t: ApplicationTranslatorT;
    /**
     * @stable [19.04.2018]
     * @returns {IApplicationSettings}
     */
    protected readonly settings: IApplicationSettings;
    /**
     * @stable [23.04.2018]
     * @returns {Map<IUniversalComponentClassEntity, UniversalComponentPluginFactoryT>}
     */
    private readonly uiPlugins;
    /**
     * @stable [13.05.2018]
     * @returns {IDateConverter}
     */
    protected readonly dc: IDateConverter;
    /**
     * @stable [13.05.2018]
     * @returns {INumberConverter}
     */
    protected readonly nc: INumberConverter;
    /**
     * @stable [18.05.2018]
     * @returns {IUIFactory}
     */
    protected readonly uiFactory: IUIFactory;
    /**
     * @stable [23.04.2018]
     * @param {IUniversalComponentPluginClassEntity} pluginClassEntity
     * @returns {IUniversalComponentPlugin}
     */
    private registerPlugin;
}
