"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var di_1 = require("../../di");
var UniversalComponent = /** @class */ (function (_super) {
    __extends(UniversalComponent, _super);
    /**
     * @stable [23.04.2018]
     * @param {TProps} props
     */
    function UniversalComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.plugins = [];
        var dynamicPluginFactory = _this.uiPlugins.get(_this.constructor);
        if (dynamicPluginFactory) {
            _this.plugins.push(dynamicPluginFactory(_this));
        }
        [].concat(props.plugins || []).forEach(function (plugin) { return _this.registerPlugin(plugin); });
        return _this;
    }
    /**
     * @stable [23.04.2018]
     */
    UniversalComponent.prototype.componentDidMount = function () {
        this.plugins.forEach(function (plugin) { return plugin.componentDidMount && plugin.componentDidMount(); });
        var props = this.props;
        if (props.register) {
            props.register(this);
        }
    };
    /**
     * @stable [23.04.2018]
     */
    UniversalComponent.prototype.componentWillUnmount = function () {
        this.plugins.forEach(function (plugin) { return plugin.componentWillUnmount && plugin.componentWillUnmount(); });
        var props = this.props;
        if (props.unregister) {
            props.unregister(this);
        }
    };
    /**
     * @stable [23.04.2018]
     * @param {Readonly<TProps extends IUniversalComponentEntity>} prevProps
     * @param {Readonly<TState>} prevState
     * @param {never} prevContext
     */
    UniversalComponent.prototype.componentDidUpdate = function (prevProps, prevState, prevContext) {
        this.plugins.forEach(function (plugin) {
            return plugin.componentDidUpdate && plugin.componentDidUpdate(prevProps, prevState, prevContext);
        });
    };
    Object.defineProperty(UniversalComponent.prototype, "self", {
        /**
         * @stable [18.05.2018]
         * @returns {Element}
         */
        get: function () {
            return this.refs.self;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalComponent.prototype, "t", {
        /**
         * @stable [19.04.2018]
         * @returns {ApplicationTranslatorT}
         */
        get: function () {
            return di_1.staticInjector(di_1.DI_TYPES.Translate);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalComponent.prototype, "settings", {
        /**
         * @stable [19.04.2018]
         * @returns {IApplicationSettings}
         */
        get: function () {
            return di_1.staticInjector(di_1.DI_TYPES.Settings);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalComponent.prototype, "uiPlugins", {
        /**
         * @stable [23.04.2018]
         * @returns {Map<IUniversalComponentClassEntity, UniversalComponentPluginFactoryT>}
         */
        get: function () {
            return di_1.staticInjector(di_1.DI_TYPES.UIPlugins);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalComponent.prototype, "dc", {
        /**
         * @stable [13.05.2018]
         * @returns {IDateConverter}
         */
        get: function () {
            return di_1.staticInjector(di_1.DI_TYPES.DateConverter);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalComponent.prototype, "nc", {
        /**
         * @stable [13.05.2018]
         * @returns {INumberConverter}
         */
        get: function () {
            return di_1.staticInjector(di_1.DI_TYPES.NumberConverter);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalComponent.prototype, "uiFactory", {
        /**
         * @stable [18.05.2018]
         * @returns {IUIFactory}
         */
        get: function () {
            return di_1.staticInjector(di_1.DI_TYPES.UIFactory);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [23.04.2018]
     * @param {IUniversalComponentPluginClassEntity} pluginClassEntity
     * @returns {IUniversalComponentPlugin}
     */
    UniversalComponent.prototype.registerPlugin = function (pluginClassEntity) {
        var plugin = Reflect.construct(pluginClassEntity, [this]);
        this.plugins.push(plugin);
        return plugin;
    };
    return UniversalComponent;
}(react_1.Component));
exports.UniversalComponent = UniversalComponent;
//# sourceMappingURL=universal.component.js.map