"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../../util");
var AutoScrollTopPlugin = /** @class */ (function () {
    /**
     * @stable [27.10.2018]
     * @param {IUniversalComponent} component
     */
    function AutoScrollTopPlugin(component) {
        this.component = component;
    }
    /**
     * @stable [27.10.2018]
     * @param {Readonly<{}>} prevProps
     * @param {Readonly<{}>} prevState
     */
    AutoScrollTopPlugin.prototype.componentDidUpdate = function (prevProps, prevState) {
        this.updateScrollTop();
    };
    /**
     * @stable [27.10.2018]
     */
    AutoScrollTopPlugin.prototype.componentDidMount = function () {
        this.updateScrollTop();
    };
    /**
     * @stable [27.10.2018]
     */
    AutoScrollTopPlugin.prototype.updateScrollTop = function () {
        var el = this.component.self;
        var contentHeight = util_1.getContentHeight(el);
        if (this.contentHeight !== contentHeight) {
            el.scrollTop = util_1.getContentHeight(el);
            this.contentHeight = contentHeight;
        }
    };
    return AutoScrollTopPlugin;
}());
exports.AutoScrollTopPlugin = AutoScrollTopPlugin;
//# sourceMappingURL=auto-scroll-top.plugin.js.map